%define qtversion 2.1.0
%define qtdir /usr/lib/qt-%{qtversion}
%define KDEDATE 20000324
%define version 1.89.%{KDEDATE}
%define kderelease 1mdk
%define sourcedir stable/%{version}/distribution/tar/generic/source
%define name kdelibs2
%define kdeprefix /opt/kde2

Name: %{name}
Icon: kde-icon.xpm
Summary: K Desktop Environment - Libraries
Version: %{version}
Release: %{kderelease}
#Serial: 1
Source0: ftp://ftp.kde.org/pub/kde/%{sourcedir}/%{name}-%{KDEDATE}.tar.bz2
Group: System Environment/Libraries
Copyright: LGPL
Group: System/Libraries
BuildRoot: /%{_tmppath}/%{name}-buildroot
Prefix: %{_prefix}
Requires: qt21
    #, kdesupport <- commented for now (David)

%description
Libraries for the K Desktop Environment
KDE Libraries included:
  dcop (Inter-process communication), kdecore (KDE core library),
  kdeui (user interface), khtml (HTML widget, java, javascript),
  kfile (file dialog), kspell (spelling checker), kab (addressbook),
  kimgio (image manipulation), kparts (component model),
  kio (network transparency), kdesu (su frontend), kstyles (widget styles)

%package devel
Group: Development/KDE and QT
Summary: Header files and documentation for compiling KDE applications.
Requires: qt21-devel, %{name} = %{version}

%description devel
This package includes the header files you will need to compile
applications for KDE.  Also included is the KDE API documentation in HTML
format for easy browsing.

%package sound
Group: System/Libraries
Summary: K Desktop Environment - Libraries for Sound Support
Requires: %{name} = %{version}

%description sound
Libraries for sound support in the K Desktop Environment:
arts, libkmid and mediatool.

%package sound-devel
Group: Development/KDE and QT
Summary: Header files and documentation for compiling KDE applications with sound.
Requires: qt21-devel, %{name}-sound = %{version}

%description sound-devel
This package includes the header files you will need to compile
applications for KDE using sound. Also included is the KDE API documentation
in HTML format for easy browsing.

%prep
rm -rf $RPM_BUILD_ROOT

%setup -q -n kdelibs
make -f Makefile.cvs

%build
export QTDIR=%{qtdir}

CFLAGS="$RPM_OPT_FLAGS" CXXFLAGS="$RPM_OPT_FLAGS -DNO_DEBUG -DNDEBUG -fexceptions" \
	./configure --prefix=%{kdeprefix} \
	--enable-final \
	--includedir=%{kdeprefix}/include # /kde <- for releases
# Remove enable-final if it doesn't compile. It makes compilation faster, better
# binaries, but sometimes the code needs some tweakings

# Compile mcopidl with no optimization, it just requires too much memory
perl -pi -e 's/-fexpensive-optimizations//;s/-O3//;s/-pipe//' arts/mcopidl/Makefile

uname -a |grep -iq smp && make -j 2 || make

%install
export DESTDIR=$RPM_BUILD_ROOT
make DESTDIR=$RPM_BUILD_ROOT install-strip

chmod a+x $RPM_BUILD_ROOT/opt/kde2/lib/*

#
for i in `find $RPM_BUILD_ROOT/ -type 'f' -perm '+a=x' `;do
    file $i|grep -q "not stripped" && strip $i
done

# Generate full documentation (including sound)
# This requires kdoc (makekdedoc and qt2doc scripts) which needs
# to be installed on the build machine...
makekdedoc=%{kdeprefix}/bin/makekdedoc
if [ ! -z "$makekdedoc" ]; then
  kdocdir=$RPM_BUILD_ROOT/usr/doc/%{name}-devel-%{version}-%{release}
  mkdir -p $kdocdir
  qt2kdoc=%{kdeprefix}/bin/qt2kdoc
  if [ ! -z "$qt2kdoc" ]; then
    $qt2kdoc -o $kdocdir /usr/share/doc/qt-%{qtversion}*/html
  fi
  $makekdedoc --rule-file=kdoc.rules --outputdir=$kdocdir --kdoc=%{kdeprefix}/bin/kdoc
fi

# Create file list for sound (headers, then libs)
# For this, install the sound stuff under sound/
(
  cd arts ; make DESTDIR=$RPM_BUILD_ROOT/sound install-strip
  cd ../libkmid ; make DESTDIR=$RPM_BUILD_ROOT/sound install-strip
  cd ../mediatool ; make DESTDIR=$RPM_BUILD_ROOT/sound install-strip

  cd $RPM_BUILD_ROOT/sound

  # Move sound docs from kdelibs2-devel to kdelibs2-sound-devel in /usr/doc/
  mkdir -p $RPM_BUILD_ROOT/usr/doc/%{name}-sound-devel-%{version}-%{release}
  ( cd $kdocdir
    for dir in arts libkmid mediatool; do
      if [ -d "$dir" ]; then
        mv $kdocdir/$dir $RPM_BUILD_ROOT/usr/doc/%{name}-sound-devel-%{version}-%{release}
      fi
    done
  )

  rm -f $RPM_BUILD_DIR/file.list.%{name}-sound $RPM_BUILD_DIR/file.list.%{name}-sound-devel
  # All dirs handled by kdelibs
  #find . -type d | sed '1,3d;s,^\.,\%attr(-\,root\,root) \%dir ,' > \
  #		$RPM_BUILD_DIR/file.list.%{name}-sound

  # Headers files -> sound-devel
  # (Not .so files, see below)
  find . -type f -name '*.h' | sed -e 's|^\.|\%attr(-,root,root) |' >> \
		$RPM_BUILD_DIR/file.list.%{name}-sound-devel

  echo "%docdir" /usr/doc/%{name}-devel-%{version}-%{release} >> \
	$RPM_BUILD_DIR/file.list.%{name}-sound-devel

  # Libs and bins -> sound
  find . -name '*.so*' -o -name '*.la' | sed -e 's|^\.|\%attr(-,root,root) |' >> \
		$RPM_BUILD_DIR/file.list.%{name}-sound

  find . -type f | grep '/bin' | sed -e 's|^\.|\%attr(-,root,root) |' >> \
		$RPM_BUILD_DIR/file.list.%{name}-sound

  ## Add here if in the future there are pixmaps, apps data...

  ## Prevent it from getting picked up by the finds below
  rm -rf $RPM_BUILD_ROOT/sound
) || exit 1

# Build file list for the rest of kdelibs
cd $RPM_BUILD_ROOT
# Use the following line for releases that go straight to /usr:
#find . -type d | sed -e '1,2d;s|^\.|\%attr(-,root,root) \%dir |' > \

find . -type d | sed -e '1,3d;s|^\.|\%attr(-,root,root) \%dir |' > \
		$RPM_BUILD_DIR/master.list

find . -type f | sed -e 's|^\.|\%attr(-,root,root) |' \
                     -e 's/\([^ ]* \)\([^ ]* [^ ]*\)/\1"\2"/' | \
    while read file ; do \
         grep -q "$file\$" `echo $RPM_BUILD_DIR/file.list.%{name}-sound*` || \
	    echo $file >> $RPM_BUILD_DIR/master.list ; \
    done

#The sed on the second line is for the file "40 Colors"
#The while and grep rules out files that are part of kdelibs-sound*

# -e '/\/config\//s|^|%config|'   removed, those aren't really config files,
#in kdelibs: color palettes, protocol config, default kdebugrc, default .rc...
#No need to back up existing files for those, IMHO.

find . -type l | sed -e 's|^\.|\%attr(-,root,root) |' | \
    while read link ; do \
         grep -q "$link\$" `echo $RPM_BUILD_DIR/file.list.%{name}-sound*` || \
	    echo $link >> $RPM_BUILD_DIR/master.list ; \
    done

grep "/include" $RPM_BUILD_DIR/master.list > \
	$RPM_BUILD_DIR/file.list.%{name}-devel
# KDE 2 contains many non-versionned libs (dlopened shared libs)
# Those have to be in kdelibs, not in kdelibs-sound
#grep ".so$" $RPM_BUILD_DIR/master.list >> \
#	$RPM_BUILD_DIR/file.list.%{name}-devel
grep /doc/%{name}-devel $RPM_BUILD_DIR/master.list >> \
	$RPM_BUILD_DIR/file.list.%{name}-devel
grep /doc/%{name}-sound-devel $RPM_BUILD_DIR/master.list >> \
	$RPM_BUILD_DIR/file.list.%{name}-sound-devel

# All the rest
egrep -v "/include|/doc|/man/man1|/usr$" \
	$RPM_BUILD_DIR/master.list > \
	$RPM_BUILD_DIR/file.list.%{name}

echo "%docdir" /usr/doc/%{name}-devel-%{version}-%{release} >> \
	$RPM_BUILD_DIR/file.list.%{name}-devel

%clean
#rm -rf $RPM_BUILD_ROOT
#rm -rf $RPM_BUILD_DIR/master.list
#rm -rf $RPM_BUILD_DIR/file.list.%{name}
#rm -rf $RPM_BUILD_DIR/file.list.%{name}-devel
#rm -rf $RPM_BUILD_DIR/file.list.%{name}-sound
#rm -rf $RPM_BUILD_DIR/file.list.%{name}-sound-devel

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files -f ../file.list.%{name}

%files devel -f ../file.list.%{name}-devel

%files sound -f ../file.list.%{name}-sound

%files sound-devel -f ../file.list.%{name}-sound-devel

%changelog
* Fri Mar 24 2000 David Faure <david@mandrakesoft.com> 1.89.20000324-1mdk
- current snapshot
- updated description
- moved programming docs to /usr/doc/kdelibs-devel-%{version}-%{release}
  and to kdelibs-devel package, taken from Bernhard Rosenkraenzer <bero@redhat.com>
- split the package, to separate sound stuff: kdelibs-sound and kdelibs-sound-devel

* Mon Dec  1 1999 David Faure <david@mandrakesoft.com> 1.80.19991204-1mdk
- renamed packages as "kdelibs2" to make it easy to keep KDE-1.x around
- current snapshot
- added qt version number in Requires
- readded kdoc HTML help - needs kdoc2

* Mon Nov  1 1999 Bernhard Rosenkraenzer <bero@redhat.com>
- almost completely rewrite spec file - move to DESTDIR system
- current snapshot

* Thu Oct 15 1999 Bernhard Rosenkraenzer <bero@redhat.de>
- 2.0 snapshots
- Change prefix to /opt/kde2 so we can coexist with KDE 1.x
- kdelibs-devel requires kdelibs

* Thu Sep 23 1999 Preston Brown <pbrown@redhat.com>
- move kde_htmldir to /usr/doc/kde
- mark doc files as such

* Tue Sep 21 1999 Preston Brown <pbrown@redhat.com>
- fix up perl include path for kdoc

* Thu Sep 16 1999 Preston Brown <pbrown@redhat.com>
- remove linking to qimgio from kdecore, moved to kpanel/kfm directly
- renamed "lowcolor" directory to "locolor"

* Mon Sep 13 1999 Preston Brown <pbrown@redhat.com>
- added lowcolor icons directory and /usr/share/pixmaps to icon search path
- hacking to recognize .desktop files as application/x-kdelnk

* Thu Sep 09 1999 Preston Brown <pbrown@redhat.com>
- added kdoc index files.

* Wed Sep 08 1999 Preston Brown <pbrown@redhat.com>
- updated to KDE 1.1.2.
- use /usr/lib/qt-1.44 as qt root.
- separate devel subpackages; include documentation and kdoc.
- added KDE icon.
- relocated includes to /usr/include/kde

* Fri Jun 11 1999 Preston Brown <pbrown@redhat.com>
- snapshot, includes kde 1.1.1 + fixes

* Mon Apr 19 1999 Preston Brown <pbrown@redhat.com>
- last snapshot before release

* Mon Apr 12 1999 Preston Brown <pbrown@redhat.com>
- latest stable snapshot

* Wed Feb 24 1999 Preston Brown <pbrown@redhat.com>
- Injected new description and group.

* Mon Feb 08 1999 Preston Brown <pbrown@redhat.com>
- upgraded to KDE 1.1 final.

* Fri Jan 15 1999 Preston Brown <pbrown@redhat.com>
- updated macros for RPM 3.0, removed redhat-release dependency

* Tue Jan 05 1999 Preston Brown <pbrown@redhat.com>
- re-integrated changes from Duncan Haldane








